
Summary: Thread-safe hash algorithms library
Name: mhash
Version: 0.9.9.9
Release:    1%{?dist}
URL: http://mhash.sourceforge.net/
License: LGPL-2.1-or-later
Source0: http://downloads.sourceforge.net/mhash/mhash-%{version}.tar.bz2
Patch2: mhash-0.9.9.9-align.patch
Patch3: mhash-0.9.9.9-force64bit-tiger.patch
Patch4: mhash-0.9.9.9-fix-snefru-segfault.patch
Patch5: mhash-0.9.9.9-fix-mem-leak.patch
Patch6: mhash-0.9.9.9-fix-whirlpool-segfault.patch
Patch7: mhash-0.9.9.9-autotools-namespace-stomping.patch
Patch8: mhash-0.9.9.9-maxint.patch
Patch9: mhash-0.9.9.9-alignment.patch
Patch10: mhash-0.9.9.9-keygen_test_fix.patch
Patch11: mhash-0.9.9-no-free-before-use.patch

BuildRequires: make
BuildRequires:  gcc
BuildRequires: autoconf, automake
Provides: libmhash = %{version}-%{release}

%description
Mhash is a free library which provides a uniform interface to a
large number of hash algorithms.

These algorithms can be used to compute checksums, message digests,
and other signatures. The HMAC support implements the basics for
message authentication, following RFC 2104. In the later versions
some key generation algorithms, which use hash algorithms, have been
added. Currently, the library supports the algorithms: ADLER32, GOST,
HAVAL256, HAVAL224, HAVAL192, HAVAL160, HAVAL128, MD5, MD4, MD2,
RIPEMD128/160/256/320, TIGER, TIGER160, TIGER128, SHA1/224/256/384/512,
Whirlpool, SNEFRU128/256, CRC32B and CRC32 checksums.


%package -n %{name}-devel
Summary: Header files and libraries for developing apps which use mhash
Requires: %{name} = %{version}-%{release}
Provides: libmhash-devel = %{version}-%{release}

%description -n %{name}-devel
This package contains the header files and libraries needed to
develop programs that use the mhash library.


%prep
%setup -q
%patch2 -p1 -b .alignment
%patch3 -p1 -b .force64bit-tiger
%patch4 -p1 -b .fix-snefru-segfault
%patch5 -p1 -b .fix-mem-leak
%patch6 -p1 -b .fix-whirlpool-segfault
%patch7 -p1 -b .fix-autotool-stomping
%patch8 -p1 -b .maxint
%patch9 -p1 -b .alignment2
%patch10 -p1 -b .fix
%patch11 -p1 -b .nofree
autoconf

%build
%configure --enable-shared %{?_with_static: --enable-static} %{!?_with_static: --disable-static}

grep 'define SIZEOF_' include/mutils/mhash_config.h && exit 1

make %{?_smp_mflags}


%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} install

sed -i 's!\(#define \(PACKAGE\|VERSION \).*\)!/* \1 */!g' %{buildroot}%{_includedir}/mutils/mhash_config.h


%check
make check





%files -n %{name}
%doc AUTHORS COPYING NEWS README THANKS TODO
%{_libdir}/*.so.*


%files -n %{name}-devel
%doc ChangeLog ./doc/*.c ./doc/skid2-authentication
%{_includedir}/*.h
%{_includedir}/mutils/
%{?_with_static: %{_libdir}/*.a}
%{_libdir}/*.so
%exclude %{_libdir}/*.la
%{_mandir}/man3/*


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.9.9-1
- initial build
